Im = imread('cityhall.jpg');
Im2 = double(Im); %<- convert image data to 'doubles' that we can compute with
A = Im2 / 255.0;  %<- scale image data to [0,1.0]

[num_pixels_Y, num_pixels_X, num_color_channels] = size(A)

% We want to use each of the pixels as a data point with a color
% specified by num_color_channels(=3) color channels. That is
% We use  num_pixels_Y * num_pixels_X pixels each consisting of 3 
% features.
X = reshape(A, num_pixels_Y * num_pixels_X, num_color_channels);

% Try different values of K and max_iterations here
K = 8; 
max_iterations = 20;
initial_centroids = kMeansInitialization(X, K);
[centroids, idx] = kMeans(X, initial_centroids, max_iterations);

% Find closest cluster members for each pixel:
cluster_index_in_image = TODO

% now recover the image from the indices (cluster_index_in_image) by 
% mapping each pixel to the centroid value
X_recovered = TODO

% Reshape the recovered image into proper dimensions
X_recovered = reshape(X_recovered, num_pixels_Y, num_pixels_X, num_color_channels);

subplot(1, 2, 1);
imagesc(A); 
title('Original');
subplot(1, 2, 2);
imagesc(X_recovered)
title(sprintf('Compressed, with %d colors.', K));

